package com.example.demo.controller;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.servlet.ModelAndView;

import com.example.demo.model.Persona;
import com.example.demo.service.IPersonaService;

@Controller
public class IndexController {
	@Autowired
	@Qualifier("personaService")
	private IPersonaService personaService;
	private static final Log LOGGER = LogFactory.getLog(IndexController.class);
	
	@GetMapping("/index")
	public String getIndexPage(Model model) {
		LOGGER.info("CONTROLLER: IndexController with /index get method");
		LOGGER.info("METHOD: getIndexPage()");
		LOGGER.info("RESULT: visualiza la página index.html");
		model.addAttribute(personaService.getPersona());
		return "index";
	}
	
	@PostMapping("/processForm")
	public ModelAndView processForm(@ModelAttribute("persona") Persona unaPersona) {
		
		LOGGER.info("CONTROLLER: IndexController with /processForm post method");
		// a continuación se hace una fe de erratas.. no debe mostrar el paramétro como personaService.getPersona()
		// porque lo que debemos mostrar es el parámetro. Esto en el vídeo quedó mal. por eso el null de persona en el tiempo 1:47:34
		LOGGER.info("METHOD: processForm()  ---- PARAMS: persona '" + unaPersona + "'");
		
		ModelAndView model = new ModelAndView("resultado");
		personaService.getPersona().setNombre(unaPersona.getNombre());
		model.addObject("person",personaService.getPersona());
	
		LOGGER.info("RESULT: visualiza la página resultado.html -- PARAMS: '"+personaService.getPersona()+"'");
		return model;
	}
}
